/************************************************************************/
/*                        ReadMTLFile()				*/
/************************************************************************/
CPLErr HDF4Dataset::ReadMTLFile()
{
  char **fileList = GetFileList();
  if ( ( !fileList ) || ( !CSLCount( fileList ) ) )
  {
    return CE_Failure;
  }
  if (!EQUAL( CPLGetExtension( fileList[0] ), "L1G"))
  {
    return CE_Failure;
  }
  const char *path = CPLGetPath( fileList[0] );
  CPLString MLTFilename = path;
  MLTFilename += "/";
  const char *basename = CPLGetBasename( fileList[0] );
  if ( !basename ) return CE_Failure;
  const char *stop = strstr( basename, "_HDF");
  if ( !stop ) return CE_Failure;
  int count = ( stop - basename );
  if ( !count ) return CE_Failure;
  MLTFilename.append( basename, count ); 
  MLTFilename += "_MTL.L1G";

  VSIStatBuf statBuf;
  if( CPLStat( MLTFilename.c_str(), &statBuf ) ) return CE_Failure;

  FILE * fp = NULL;
  char line[1025];
  fp = VSIFOpen( MLTFilename.c_str(), "r");
  if ( fp == NULL ) return CE_Failure;

  while ( !VSIFEof( fp ) )
  {
    if( VSIFGets( line, 1024, fp ) )
    {
      if ( ( strstr( line, "GROUP =" ) ) || ( strstr( line, "END_GROUP =" ) ) ) 
        continue;
      else 
      {
        char **tokens = CSLTokenizeString2( line, "=", CSLT_PRESERVEQUOTES | CSLT_STRIPENDSPACES | CSLT_STRIPLEADSPACES );
        int count = CSLCount( tokens );
        if ( ( tokens ) && ( count == 2 ) )
        {
          CPLString name = "L1G_";
          name += tokens[0];
          SetMetadataItem( name.c_str(), tokens[1] );
        }
      }
    }
  }
  VSIFClose( fp );

  return CE_None;
}
